# Adds capability to navigate through posts pages.
module Navigation
  # Navigates to posts page based off of store_posts_url.
  def go_to_posts_page
    find_posts_url
    store_posts_url
    @current_page = @posts_url.click
  end

  # Navigates to previous Mechanize page.
  def previous_page
    @current_page = @agent.get(@agent.back['href'])
  end

  # Sets current element to 'Popular' indicator.
  def go_to_popular
    if see_popular? == false
      puts 'Nothing says "Popular" on this page'
    else
      store_indicator
      @current_element = @indicator
      @current_element
    end
  end

  # Returns parent of current Nokogiri element
  def find_parent
    @parent = @current_element.parent # one element higher, the div container
  end

  # Changes current Nokogiri element to its parent.
  def ascend
    if @current_element.ancestors.empty? == true # no more room to ascend
      puts 'At highest element.  Nothing left to ascend.'
    else
      @current_element = @current_element.parent
    end
  end

  def auto_ascend
    ascend until see_multiple_links? == true
    @current_element
  end

  def locate_popular_links
    if possible_success? == false
      ignorance_error
    elsif see_popular? == true
      crawl_popular
    elsif see_posts? == true
      go_to_posts_page
      see_popular? == true ? crawl_popular : ignorance_error
    end
  end

  # Examine popular element and climb DOM tree until multiple
  # links are present.
  def crawl_popular
    go_to_popular
    auto_ascend
  end
end
